<template>
    <NuxtLayout :name="'dashboard'">
        <div class="flex justify-evenly container p-8">
            <div class="p-2 my-12 rounded-lg lg:w-1/3 xl:1/2 h-fit border-solid border-slate-300 border-2">
                <DynamicForm :fields="fields" :formTitle="formTitle" :submitName="submitName" :onSubmit="onSubmit" />
            </div>
        </div>
    </NuxtLayout>
</template>

<script lang="ts">

definePageMeta({
    middleware: ["auth"],
});

interface formTemplate {
    title: string;
    description: string;
}

export default {
    data() {
        return {
            formTitle: "Edit Application",
            submitName: "Save",
            isLoading: false,
            paymentId: '',
            status: '',
            form: {
                title: '',
                description: '',
            },
            fields: [
                { id: "title", name: "Title", type: "text", value: "" },
                { id: "description", name: "Description", type: "text", value: "" },
            ],
        };
    },
    mounted() {
        this.paymentId = this.$route.params.payment_id as string;
        this.fetchData();
    },
    methods: {
        fetchData() {
            const toastStore = useToastStore();
            const accessToken: string = localStorage.getItem("access_token")!;
            this.$api.get(`/application/${this.paymentId}`,
                {
                    headers: {
                        'Accept': 'application/json',
                        'Authorization': `Bearer ${accessToken}`,
                    },
                })
                .then((response) => {
                    const data = response.data;
                    this.form.title = data.title;
                    this.form.description = data.description;
                    this.status = data.status;
                    this.formToField(response.data);
                })
                .catch((error) => {
                    console.log(error)
                })
        },
        onSubmit(data: formTemplate) {
            this.isLoading = true;
            const toastStore = useToastStore();
            const accessToken: string = localStorage.getItem("access_token")!;
            const title = this.form.title;
            const description = this.form.description;

            this.$api
                .put(`/application/${this.paymentId}`,
                    { ...data, status: this.status },
                    {
                        headers: {
                            'Accept': 'application/json',
                            'Authorization': `Bearer ${accessToken}`,
                        },
                    }
                )
                .then((response) => {
                    console.log(response);
                    toastStore.showToast('success', "Data stored successfully");
                    this.$router.replace("/application");
                })
                .catch((error) => {
                    console.log(error);
                    const detail = error.response.data.detail;
                    let message = "";
                    if (detail[0].msg) {
                        message = detail[0].msg;
                    } else {
                        message = detail;
                    }
                    toastStore.showToast(message, 'danger');
                }).finally(() => {
                    this.isLoading = false;
                })
        },
        fieldsToForm(fields: typeof this.fields) {
            fields.forEach((field) => {
                // Check if the field.id exists as a property in the form object
                if (this.form.hasOwnProperty(field.id)) {
                    this.form[field.id as keyof formTemplate] = field.value;
                }
            });
        },
        formToField(form: formTemplate) {
            this.fields.forEach((field) => {
                // Check if the field.id exists as a property in the form object
                if (form.hasOwnProperty(field.id)) {
                    if (field.id !== "password")
                        field.value = form[field.id as keyof formTemplate];
                }
            });
        },
    },
};
</script>
